using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace UnifiedPOS.GestureControl.V1_4
{
    [ServiceContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public interface GestureControl
    {
        #region Version 1.4

        //
        // Common Properties
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetAutoDisableResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //bool GetAutoDisable(string ConsumerID);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetAutoDisableResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //void SetAutoDisable(string ConsumerID, bool AutoDisable);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapCompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapCompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapCompareFirmwareVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapPowerReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapPowerReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        PowerReporting GetCapPowerReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapStatisticsReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapStatisticsReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapStatisticsReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapUpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapUpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapUpdateFirmware(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapUpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapUpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapUpdateStatistics(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCheckHealthText", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCheckHealthTextResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetCheckHealthText(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetClaimed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetClaimedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetClaimed(string ConsumerID);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDataCount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDataCountResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //int GetDataCount(string ConsumerID);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDataEventEnabledResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //bool GetDataEventEnabled(string ConsumerID);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetDataEventEnabledResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //void SetDataEventEnabled(string ConsumerID, bool DataEventEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetDeviceEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetDeviceEnabled(string ConsumerID, bool DeviceEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetFreezeEvents(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetFreezeEvents(string ConsumerID, bool FreezeEvents);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetOutputID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetOutputIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        int GetOutputID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        PowerNotification GetPowerNotify(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetPowerNotify(string ConsumerID, PowerNotification PowerNotify);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPowerState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPowerStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        PowerState GetPowerState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        ControlState GetState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceControlDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceControlDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetDeviceControlDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceControlVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceControlVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        UposVersion GetDeviceControlVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceServiceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceServiceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetDeviceServiceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceServiceVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetDeviceServiceVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        UposVersion GetDeviceServiceVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPhysicalDeviceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPhysicalDeviceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetPhysicalDeviceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPhysicalDeviceName", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPhysicalDeviceNameResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetPhysicalDeviceName(string ConsumerID);

        //
        // Specific Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapAssociatedHardTotalsDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapAssociatedHardTotalsDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetCapAssociatedHardTotalsDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapMotion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapMotionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapMotion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapMotionCreation", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapMotionCreationResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapMotionCreation(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapPose", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapPoseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapPose(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapPoseCreation", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapPoseCreationResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetCapPoseCreation(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapStorage", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetCapStorageResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        CapStorage GetCapStorage(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetAutoMode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetAutoModeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetAutoMode(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetAutoMode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetAutoModeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetAutoMode(string ConsumerID, string AutoMode);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetAutoModeList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetAutoModeListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        AutoModeList GetAutoModeList(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetJointList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetJointListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        JointList GetJointList(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetMotionList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetMotionListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        MotionList GetMotionList(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPoseCreationMode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPoseCreationModeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        bool GetPoseCreationMode(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetPoseCreationMode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetPoseCreationModeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetPoseCreationMode(string ConsumerID, bool PoseCreationMode);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPoseList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPoseListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        PoseList GetPoseList(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetStorage", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetStorageResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        Storage GetStorage(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetStorage", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetStorageResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetStorage(string ConsumerID, Storage Storage);

        //
        // Common Methods
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/Open", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/OpenResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //void Open(string ConsumerID, string EndpointAddress);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/Close", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CloseResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //void Close(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/Claim", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ClaimResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void Claim(string ConsumerID, int Timeout);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/Release", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ReleaseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void Release(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CheckHealth", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CheckHealthResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void CheckHealth(string ConsumerID, HealthCheckLevel Level);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ClearInput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ClearInputResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //void ClearInput(string ConsumerID);

        // [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ClearInputProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ClearInputPropertiesResponse")]
        // [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        // void ClearInputProperties(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ClearOutput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ClearOutputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void ClearOutput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/DirectIO", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/DirectIOResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        DirectIOData DirectIO(string ConsumerID, int Command, int Data, object Obj);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        CompareFirmwareResult CompareFirmwareVersion(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ResetStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/ResetStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void ResetStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/RetrieveStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/RetrieveStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string RetrieveStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void UpdateFirmware(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void UpdateStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        //
        // Specific Methods
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CreateMotion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CreateMotionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void CreateMotion(string ConsumerID, string FileName, PoseList PoseList);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CreatePose", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CreatePoseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void CreatePose(string ConsumerID, string FileName, int Time);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPosition", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetPositionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        int GetPosition(string ConsumerID, string JointID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetPosition", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetPositionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetPosition(string ConsumerID, PositionList PositionList, int Time, bool Absolute);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetSpeed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetSpeedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetSpeed(string ConsumerID, SpeedList SpeedList, int Time);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/StartMotion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/StartMotionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void StartMotion(string ConsumerID, string FileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/StartPose", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/StartPoseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void StartPose(string ConsumerID, string FileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/StopControl", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/StopControlResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void StopControl(string ConsumerID, int OutputID);

        //
        // Session Management
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetWSPOSVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetWSPOSVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        UposVersion GetWSPOSVersion();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GenerateConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GenerateConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GenerateConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/OpenSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/OpenSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void OpenSession(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CloseSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CloseSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void CloseSession(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetProviderSessionTimeout", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetProviderSessionTimeoutResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        int GetProviderSessionTimeout(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/KeepAlive", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/KeepAliveResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void KeepAlive(string ConsumerID);

        //
        // Device Control
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/OpenDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/OpenDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void OpenDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CloseDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/CloseDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void CloseDevice(string ConsumerID);

        //
        // Event Polling
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/PollForUPOSEvent", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/PollForUPOSEventResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        GestureControlEvent PollForUPOSEvent(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetEventResponse", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetEventResponseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        void SetEventResponse(string ConsumerID, GestureControlEventResponse EventResponse);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetEncryptedClaimedConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/GetEncryptedClaimedConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        string GetEncryptedClaimedConsumerID();

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetEventRequestProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/SetEventRequestPropertiesResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/UposException", Name = "UposException")]
        //void SetEventRequestProperties(string ConsumerID, PropertyNameList list);

        #endregion Version 1.4
    }

    #region Version 1.4

    //
    // Common Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DirectIOData
    {
        [DataMember]
        public int Data { get; set; }

        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class UposException
    {
        [DataMember]
        public ErrorCode ErrorCode { get; set; }

        [DataMember]
        public int ErrorCodeExtended { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class UposVersion
    {
        [DataMember]
        public int Major { get; set; }

        [DataMember]
        public int Minor { get; set; }

        [DataMember]
        public int Build { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class Statistic
    {
        [DataMember]
        public string Name { get; set; }

        [DataMember]
        public string Value { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "Statistic")]
    public class StatisticList : List<Statistic>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "CharacterSet")]
    public class CharacterSetList : List<int>
    {
    }

    //
    // Common Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum CompareFirmwareResult
    {
        [EnumMember]
        CFV_FIRMWARE_OLDER,

        [EnumMember]
        CFV_FIRMWARE_SAME,

        [EnumMember]
        CFV_FIRMWARE_NEWER,

        [EnumMember]
        CFV_FIRMWARE_DIFFERENT,

        [EnumMember]
        CFV_FIRMWARE_UNKNOWN,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum ControlState
    {
        [EnumMember]
        S_CLOSED,

        [EnumMember]
        S_IDLE,

        [EnumMember]
        S_BUSY,

        [EnumMember]
        S_ERROR,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum ErrorCode
    {
        [EnumMember]
        E_CLOSED,

        [EnumMember]
        E_CLAIMED,

        [EnumMember]
        E_NOTCLAIMED,

        [EnumMember]
        E_NOSERVICE,

        [EnumMember]
        E_DISABLED,

        [EnumMember]
        E_ILLEGAL,

        [EnumMember]
        E_NOHARDWARE,

        [EnumMember]
        E_OFFLINE,

        [EnumMember]
        E_NOEXIST,

        [EnumMember]
        E_EXISTS,

        [EnumMember]
        E_FAILURE,

        [EnumMember]
        E_TIMEOUT,

        [EnumMember]
        E_BUSY,

        [EnumMember]
        E_EXTENDED,

        [EnumMember]
        E_DEPRECATED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum HealthCheckLevel
    {
        [EnumMember]
        CH_INTERNAL,

        [EnumMember]
        CH_EXTERNAL,

        [EnumMember]
        CH_INTERACTIVE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum PowerNotification
    {
        [EnumMember]
        PN_DISABLED,

        [EnumMember]
        PN_ENABLED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum PowerReporting
    {
        [EnumMember]
        PR_NONE,

        [EnumMember]
        PR_STANDARD,

        [EnumMember]
        PR_ADVANCED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum PowerState
    {
        [EnumMember]
        PS_UNKNOWN,

        [EnumMember]
        PS_ONLINE,

        [EnumMember]
        PS_OFF,

        [EnumMember]
        PS_OFFLINE,

        [EnumMember]
        PS_OFF_OFFLINE,
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum StatisticCategories
    {
        [EnumMember]
        All,
        [EnumMember]
        Manufacturer,
        [EnumMember]
        Upos,
    }
    */

    public class StatisticCategories
    {
        public const string All = "";
        public const string Manufacturer = "M_";
        public const string Upos = "U_";
    }

    //
    // Specific Data Types
    //

    //
    // Specific Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum CapStorage
    {
        [EnumMember]
        GCTL_CST_HOST_ONLY,

        [EnumMember]
        GCTL_CST_HARDTOTALS_ONLY,

        [EnumMember]
        GCTL_CST_ALL,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum Storage
    {
        [EnumMember]
        GCTL_ST_HOST,

        [EnumMember]
        GCTL_ST_HARDTOTALS,

        [EnumMember]
        GCTL_ST_HOST_HARDTOTALS,
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "AutoMode")]
    public class AutoModeList : List<string>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class GestureJoint
    {
        [DataMember]
        public string JointId { get; set; }

        [DataMember]
        public bool Range { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "Joint")]
    public class JointList : List<GestureJoint>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "Motion")]
    public class MotionList : List<string>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "Pose")]
    public class PoseList : List<string>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class GesturePosition
    {
        [DataMember]
        public string JointId { get; set; }

        [DataMember]
        public int Position { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "Position")]
    public class PositionList : List<GesturePosition>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class GestureSpeed
    {
        [DataMember]
        public string JointId { get; set; }

        [DataMember]
        public int Speed { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "Speed")]
    public class SpeedList : List<GestureSpeed>
    {
    }

    //
    // Constants
    //

    public class ExtendedError
    {
        public const int EGCTL_NOROOM = 201;

        public const int EFIRMWARE_BAD_FILE = 281;
        public const int ESTATS_ERROR = 280;
        public const int ESTATS_DEPENDENCY = 282;
    }

    public class StatisticProperties
    {
        public const string CommunicationErrorCount = "CommunicationErrorCount";
        public const string DeviceCategory = "DeviceCategory";
        public const string FirmwareRevision = "FirmwareRevision";
        public const string HoursPoweredCount = "HoursPoweredCount";
        public const string InstallationDate = "InstallationDate";
        public const string Interface = "Interface";
        public const string ManufactureDate = "ManufactureDate";
        public const string ManufacturerName = "ManufacturerName";
        public const string MechanicalRevision = "MechanicalRevision";
        public const string ModelName = "ModelName";
        public const string SerialNumber = "SerialNumber";
        public const string UnifiedPOSVersion = "UnifiedPOSVersion";
    }

    public class Wait
    {
        public const int FOREVER = -1;
    }

    //
    // Event Polling
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class GestureControlEvent
    {
        //[DataMember]
        //public DataEvent DataEvent { get; set; }
        [DataMember]
        public DirectIOEvent DirectIOEvent { get; set; }

        [DataMember]
        public ErrorEvent ErrorEvent { get; set; }

        [DataMember]
        public OutputCompleteEvent OutputCompleteEvent { get; set; }

        [DataMember]
        public StatusUpdateEvent StatusUpdateEvent { get; set; }

        //[DataMember]
        //public DataContainedEvent DataContainedEvent { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class GestureControlEventResponse
    {
        //[DataMember]
        //public DataEventResponse DataEventResponse { get; set; }
        //[DataMember]
        //public DataContainedEventResponse DataContainedEventResponse { get; set; }
        [DataMember]
        public DirectIOEventResponse DirectIOEventResponse { get; set; }

        [DataMember]
        public ErrorEventResponse ErrorEventResponse { get; set; }

        [DataMember]
        public OutputCompleteEventResponse OutputCompleteEventResponse { get; set; }

        [DataMember]
        public StatusUpdateEventResponse StatusUpdateEventResponse { get; set; }
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DataEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DataEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    */

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DirectIOEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int EventNumber { get; set; }

        [DataMember]
        public int Data { get; set; }

        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DirectIOEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DirectIOData DirectIOData { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class ErrorEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public ErrorCode ErrorCode { get; set; }

        [DataMember]
        public int ErrorCodeExtended { get; set; }

        [DataMember]
        public ErrorLocus ErrorLocus { get; set; }

        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class ErrorEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class OutputCompleteEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int OutputID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class OutputCompleteEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class StatusUpdateEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class StatusUpdateEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum ErrorLocus
    {
        [EnumMember]
        EL_OUTPUT,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public enum ErrorResponse
    {
        [EnumMember]
        ER_CLEAR,

        [EnumMember]
        ER_RETRY,
    }

    /*
    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "PropertyName")]
    public class PropertyNameList : List<string>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/", ItemName = "Parameter")]
    public class ParameterList : Dictionary<string, object>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DataContainedEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
        [DataMember]
        public ParameterList Parameters { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DataContainedEventData
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public bool SetDataEventEnabled { get; set; }
        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/GestureControl/")]
    public class DataContainedEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public bool SetDataEventEnabled { get; set; }
        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }
    */

    #endregion Version 1.4
}